/*---------------------------------------------------------------

 simpleSlide.js
 
 jQuery required (tested on version 1.3.2)
 encoding UTF-8

 Copyright (c) 2008 nori (norimania@gmail.com)
 5509 - http://moto-mono.net
 Licensed under the MIT
 
 Document Archive:
 http://moto-mono.net/2009/04/14/simpleslide.html

 $Date: 2009-04-14 0:00
 
 ----------------------------------------------------------------*/

$(function(){
				 
	// 初期化
	var d = document,
		w = d.documentElement.clientWidth,
		slideTitle = d.title,
		sL = $("div.section").length, // Slide Length
		key = {up: 38, right: 39, down: 40, left : 37},
		current = location.hash && location.hash.match(/(\#slide\-\d+)/) ? RegExp.$1 : "#slide-0",
		currentNum = parseInt(current.replace("#slide-","")),
		title = $(">*:first-child","div.section"),
		slide = $("div.section").each(function(i){
			var cont = $(this).html();
			$(this).addClass("slide").empty().append("<div class='cont'>"+cont+"</div>").attr("id","slide-"+i);
			if(i!=0) $(this).hide();
		});		
		
	// ページ番号を付加
	$("body").addClass("simpleSlide").append("<div id='meta'><p id='page'><span id='this'>1</span> / <span id='total'>"+sL+"</span></p></div>").css("overflow","hidden");
	if(location.hash && location.hash.match(/slide\-/)) $("#this").text(location.hash.match(/slide\-(\d+)/) ? parseInt(RegExp.$1)+1 : null);
	
	$("body").append("<p id='simpleSlidePrev' class='simpleSlideSN'>Prev</p>")
		.append("<p id='simpleSlideNext' class='simpleSlideSN'>Next</p>");
	$(".simpleSlideSN").hide();
	
	// メニューを追加
	$("body").append("<div id='slideMenuBlock'><div id='slideMenuToggle'>Menu</div><ol id='slideMenu' style='display: none'></ol>");
	$("#slideMenuToggle").after("<div id='slideMenuTitle'><a href='#slide-0'>&raquo; Back To Title</a></div>");
	$("#slideMenuToggle").click(function(e){
		$("#slideMenu").slideToggle();
		e.stopPropagation();
	});
	$(title).each(function(i){
		var num = i<9 ? "0"+(i+1) : i+1; // 10以下の場合は頭に0を付ける
		$("#slideMenu").append("<li><a href='#slide-"+i+"'>"+num+". "+$(this).text()+"</a></li>");
	});
	$("#slideMenu a,#slideMenuTitle a").click(function(){
		slideTarget(this.hash);
		return false;
	});
	
	function titleRename(slideId){
		var nextTitle = $(">div>*:first-child",slideId).text();
		d.title = nextTitle+" | "+slideTitle;
	}
	
	// 次のスライド
	function slideNext(){
		if(currentNum==(sL-1)) return false;
		$("#this").text(currentNum+2);
		$(current).hide();
		$("#slide-"+(currentNum+1)).fadeIn();
		titleRename("#slide-"+(currentNum+1));
		current = "#slide-"+(currentNum+1);
		location.href = globalLocation+current;
	}
	
	// 前のスライド
	function slidePrev(){
		if(currentNum==0) return false;
		$("#this").text(currentNum);
		$(current).hide();
		$("#slide-"+(currentNum-1)).fadeIn();
		if(currentNum!=1){
			titleRename("#slide-"+(currentNum-1));
		}else{
			d.title = slideTitle;
		}
		current = "#slide-"+(currentNum-1);
		location.href = globalLocation+current;
	}
	
	// 指定のスライドを表示
	function slideTarget(id){
		currentNum = parseInt(id.replace("#slide-",""))+1;
		$("#this").text(currentNum);
		$(current).hide();
		$(id).fadeIn();
		titleRename(id)
		current = id;
		location.href = globalLocation+current;
	}
		
	// 読み進めるためのイベント登録
	$(document).keypress(function(e){
		if($("#slideMenu:visible").length>0){
			$("#slideMenu").slideToggle();
		}else{
			currentNum = parseInt(current.replace("#slide-",""));
			if(e.keyCode==key.left || e.keyCode==key.up){ // 上か左なら戻る
				slidePrev();
			}else if(e.keyCode==key.right || e.keyCode==key.down){ // 右か下なら進む
				slideNext();
			}
		}
	}).click(function(e){
		if($("#slideMenu:visible").length>0){
			$("#slideMenu").slideToggle();
		}else{
			currentNum = parseInt(current.replace("#slide-",""));
			if(e.pageX<(w/2)) slidePrev(); // クリック位置がドキュメントの左半分の場合は戻る
			else slideNext(); // じゃない場合（右）は進む
		}
	}).mousemove(function(e){
		currentNum = parseInt(current.replace("#slide-",""));
		if($("#slideMenu:visible").length>0) return false;
		if(e.pageX<(w/2)){
			$("#simpleSlideNext").hide();
			if(currentNum!=0) $("#simpleSlidePrev").show();
		}else{
			$("#simpleSlidePrev").hide();
			if(currentNum!=(sL-1)) $("#simpleSlideNext").show();
		}
	}).mouseout(function(){
		$(".simpleSlideSN").hide();
	});
	
	// リンククリック時にはdocument.clickの伝播を阻止
	$("a","div.slide").click(function(e){
		e.stopPropagation();
	});
	
	// メニューブロック、アンカーの上ではdocument.mousemoveの伝播を阻止
	$("#slideMenuBlock,.slide a").mousemove(function(e){
		e.stopPropagation();
	});
	
	// 表示スライドの初期化
	if(location.hash && location.hash.match(/slide\-\d+/)){
		$("#slide-0").hide();
		$(location.hash).show();
		titleRename(location.hash)
	}else{
		location.href = location.href+"#slide-0";
	}
	var globalLocation = location.href.replace(/\#slide-\d+/,"");
			  
});